; ⥬ , , ணࠬ   .
; ॡ ⥫쭮 ࠡ⪨!

		locals	@@

Ports		DB	8 DUP (?)

; ---------------------------------------------------------------------------
;                           ᭮ ணࠬ
; ---------------------------------------------------------------------------

Mode256x256	DB	4Bh,  3Fh,  40h
		DB	02h,  43h,  00h,  2Fh, 0B2h,  00h,  61h,  00h
		DB	00h,  00h,  00h,  00h,  00h,  04h,  25h, 0FFh
		DB	20h,  40h, 0F0h,  01h, 0A3h, 0FFh

InitMode	proc	near
		push	ds
		mov     ax, 93h
		int     10h
		push	cs
		pop	ds
		mov	di, offset Mode256x256
		call	CorrectMode
		call	InitPalette
		pop	ds
		ret
InitMode	endp

CorrectMode	proc	near
		mov	dx, 3D4h
		mov	ax, 2011h
		cli	
		out	dx, ax
		mov	dx, 3D4h
		mov	bx, 1800h
		call	SetRegisters
		sti	
		ret
CorrectMode	endp

SetRegisters	proc	near
@@1:		mov	al, bl
		mov	ah, [di]
		inc	di
		out	dx, ax
		inc	bl
		cmp	bl, bh
		jbe	@@1
		ret	
SetRegisters	endp

LvovPalette	db	 0,  0,  0		; Black
		db	 0, 63,  0		; Green
		db	 0,  0, 63		; Blue
		db	63,  0,  0		; Red

InitPalette	proc	near
		mov	ax, 1012h
		mov	bx, 4
		mov	cx, bx
		push	cs
		pop	es
		mov	dx, offset LvovPalette
		int	10h
		ret
InitPalette	endp

Init		PROC	NEAR

		cld

		push	cs
		pop	ds

		; ᢮   墮  ᠬ  :)))

		mov	ah, 4Ah
		mov	bx, (EndMark-Start+10Fh)/16
		int	21h

		; 樠 "⮢"

		mov	Ports[1], 10001111b
		mov	Ports[2], 00000010b

		; 뤥     

		mov	ah, 48h
		mov	bx, 1000h		; 64 
		int	21h

		; 㦥    

		mov	es, ax
		mov	bx, offset DataBlocks
		mov	cx, DataBlocksCnt
		cld
@@movedata:	push	cx
		mov	si, [bx]
		mov	di, [bx+2]
		mov	cx, [bx+4]
		rep movsb
		pop	cx
		add	bx, 6
		loop	@@movedata

		; ds -> ᥣ  (   ६ ࠭  ax)

		mov	ds, ax

		; 樠 ०

		call	InitMode

		; 樮쭠 樠

IFDEF InitSplash
		call	InitSplash
ENDIF

IFDEF MoveFont
		call	MoveFont
ENDIF

IFDEF InitKeyboard
		call	InitKeyboard
ENDIF

IFDEF InitTimer
		call	InitTimer
ENDIF

		; , ᮡ⢥,   樠 :)

		ret
Init		ENDP

Done		PROC	NEAR

IFDEF DoneTimer
		call	DoneTimer
ENDIF

IFDEF DoneKeyboard
		call	DoneKeyboard
ENDIF

		mov	ax, 3
		int	10h
		mov	ax, 4C00h
		int	21h
		ret
Done		ENDP

		ASSUME	DS:NOTHING

; ⥭ 祩 
; 室:   si - 
; 室:  ah - 祭

ReadMem		PROC	NEAR
		pushf
		or	si, si
		js	@@ram
		test	cs:Ports[2], 00000010b
		jnz	@@ram
		mov	ah, [si+8000h]
		jmp	short @@ret
@@ram:		mov	ah, [si]
@@ret:		popf
		ret
ReadMem		ENDP

; ⥭ ᫮ 
; 室:   si - 
; 室:  di - ᫮

ReadMemW	PROC	NEAR
		pushf
		push	ax
		call	ReadMem
		mov	al, ah
		inc	si
		call	ReadMem
		mov	di, ax
		dec	si
		pop	ax
		popf
		ret
ReadMemW	ENDP

WriteVMem	proc	near
		push	es
		push	ax
		push	bx
		push	cx
		push	di
		mov     cx, 0A000h
		mov     es, cx
		mov     di, si
		shl     di, 1
		shl	di, 1
		mov     bl, ah
		mov     cx, 4
@@01:		rol     bl, 1
		mov     ah, bl
		and     ah, 00010001b
		mov     al, ah
		and     al, 00000001b
		shr     ah, 1
		shr     ah, 1
		shr     ah, 1
		or      al, ah
		add     al, 4
		stosb
		loop    @@01
		pop	di
		pop	cx
		pop	bx
		pop	ax
		pop	es
		ret
WriteVMem	endp

;  祩 
; 室:  ah - 祭; si - 

WriteMem	PROC	NEAR
		pushf
		or	si, si
		js	@@ram
		test	cs:Ports[2], 00000010b
		jnz	@@ram
		cmp	si, 4000h
		jc	@@ret
		mov	[si+8000h], ah
		call	WriteVMem
		jmp	short @@ret
@@ram:		mov	[si], ah
@@ret:		popf
		ret
WriteMem	ENDP

;  ᫮ 
; 室: di - 祭; si - 

WriteMemW	PROC	NEAR
		pushf
		push	ax
		mov	ax, di
		xchg	ah, al
		call	WriteMem
		mov	ah, al
		inc	si
		call	WriteMem
		dec	si
		pop	ax
		popf
		ret
WriteMemW	ENDP

; 室:   ah -  
; 室:  al - 祭

InPort		PROC	NEAR
		pushf
		push	bx
		xor	bh, bh
		mov	bl, ah
		and	bl, 00000011b
		ror	ah, 1
		ror	ah, 1
		and	ah, 00000100b
		or	bl, ah
		or	ah, ah
		jnz	@@portsd_
		mov	al, cs:Ports[bx]
		jmp	short @@ret
@@portsd_:	mov	al, 0FFh
@@ret:		pop	bx
		popf
		ret
InPort		ENDP

; 室:   ah -  ; al - 祭

OutPort		PROC	NEAR
		pushf
		push	bx
		xor	bh, bh
		mov	bl, ah
		and	bl, 00000011b
		ror	ah, 1
		ror	ah, 1
		and	ah, 00000100b
		or	bl, ah
		mov	cs:Ports[bx], al
		pop	bx
		popf
		ret
OutPort		ENDP

; ---------------------------------------------------------------------------
;                           "좮᪨" ணࠬ
; ---------------------------------------------------------------------------

proc_F800	proc	near
		jmp	Done
proc_F800	endp

;  ᨬ    믮 㭪権   - F0

proc_F803	proc	near
		xor	ah, ah
		int	16h
		ret
proc_F803	endp

;  ,   proc_F803,   믮 㭪権 

proc_F806	proc	near
		jmp	proc_F803
proc_F806	endp

proc_F809	proc	near
		ret
proc_F809	endp

; 뢮 ᨬ  ਭ ;)

proc_F80C	proc	near
		ret
proc_F80C	endp

proc_F80F	proc	near
		ret
proc_F80F	endp

;  ﭨ : 0 -   , 1 - 

proc_F812	proc	near
		mov	ah, 1
		int	16h
		mov	al, 0
		jz	@@ret
		mov	al, 0FFh
@@ret:		ret
proc_F812	endp

proc_F815	proc	near
		ret
proc_F815	endp

proc_F818	proc	near
		ret
proc_F818	endp

proc_F81B	proc	near
		ret
proc_F81B	endp

proc_F81E	proc	near
		ret
proc_F81E	endp

proc_F821	proc	near
		ret
proc_F821	endp

proc_F824	proc	near
		ret
proc_F824	endp

proc_F827	proc	near
		ret
proc_F827	endp

proc_F82A	proc	near
		ret
proc_F82A	endp

proc_F82D	proc	near
		ret
proc_F82D	endp

proc_F830	proc	near
		ret
proc_F830	endp

proc_F833	proc	near
		ret
proc_F833	endp

; ⪠ ࠭.
; BE38:  ࠬ

proc_F836	proc	near
		push	ax
		push	cx
		and	cs:Ports[2], 11111101b
		mov	ah, ds:[0BE38h]
		mov	si, 4000h
		mov	cx, si
@@loop:		call	WriteMem
		inc	si
		loop	@@loop
		or	cs:Ports[2], 00000010b
		pop	cx
		pop	ax
		ret
proc_F836	endp

; ---------------------------------------------------------------------------
;                  "좮᪨" ᯮ⥫ ணࠬ
; ---------------------------------------------------------------------------

proc_C000	proc	near
		jmp	proc_F800
proc_C000	endp

proc_E4A4	proc	near
		ret
proc_E4A4	endp

proc_FFD1	proc	near
		ret
proc_FFD1	endp

proc_FFD6	proc	near
		ret
proc_FFD6	endp

; ७   cx   dx   bx

proc_E11F	proc	near
		mov	si, dx
		mov	di, bx
@@loop:		call	ReadMem
		xchg	si, di
		call	Writemem
		xchg	si, di
		inc	si
		inc	di
		loop	@@loop
		ret
proc_E11F	endp

;     cx   bx 祭 dl

proc_E12A	proc	near
		mov	ah, dl
		mov	si, bx
@@loop:		call	WriteMem
		inc	si
		loop	@@loop
		ret
proc_E12A	endp

; ஢ઠ  ᫮ bx=dx

proc_E425	proc	near
		cmp	bx, dx
		ret
proc_E425	endp

; ---------------------------------------------------------------------------
;                     ...  ᯮ⥫
; ---------------------------------------------------------------------------

proc_D201	proc	near
		ret
proc_D201	endp

proc_EBE4	proc	near
		ret
proc_EBE4	endp

proc_EBD0	proc	near
		ret
proc_EBD0	endp

proc_F067	proc	near
		ret
proc_F067	endp

proc_E2E8	proc	near
		ret
proc_E2E8	endp

proc_E343	proc	near
		ret
proc_E343	endp

proc_E42B	proc	near
		ret
proc_E42B	endp

proc_E29C	proc	near
		ret
proc_E29C	endp
